<?php

include ('/usr/local/www/berogui/includes/Helper/Helper.php');
include ('/usr/local/www/berogui/includes/Helper/HelperPstn.php');

$exec_ajax = 1;
$invalid = array();

/* [CHECKING GET REQUEST] */
$list_get = array('opt' => 'opt');

$_GET = Helper::sanitizeGet($_GET, $list_get, $exec_ajax, $invalid);

/* [CHECKING SESSION] */
$newTarget = '/app/berogui/index.php?m=Isdn&opt=' . strtolower($_GET['opt']);
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

/* [CHECKING POST REQUEST] */
include ('/usr/local/www/berogui/misc/config_parameter.php');

unset($_POST['submit']);

// TODO: the PSTN POST options should be directly into the HelperPstn rather the config_parameter file
$general_post = HelperPstn::getPostParameters('general');
$isdn_post    = HelperPstn::getPostParameters('isdn', get_pstn_post_options('isdn'));

$_POST = Helper::sanitizePost($_POST, array_merge($isdn_post['post'], $general_post['post']), $exec_ajax, $invalid, array_merge($isdn_post['options'], $general_post['options']));

/* [EXECUTING AJAX] */
if (!$exec_ajax) {
	echo "GET / POST requests not allowed";
	exit(1);
}

// ISDN Portgruppen speichern
chdir("../..");

include "./includes/variables.php";
include "./misc/database.php";
require_once "./includes/isgwtelnet.php";
$ba = new beroAri();

function parameters($config = "") {
	$default = Helper::getDefaultConfig();
	foreach ($_POST as $key => $value) {
		$_POST[$key] = str_replace("'", "\"", $_POST[$key]);
	}

	$config_array = array('ec', 'ectl', 'dton', 'oton', 'bearer_cap', 'screen',	
		'cd', 'pres', 'clir_on_oad');
	foreach ($config_array as $option) {
		if (isset($_POST[$option]) && $_POST[$option] != $default[$option])
			$config .= ',' . $option . '=' . $_POST[$option];
	}

	//ISDN_OAD_SETTING
	if (isset($_POST['isdn_oad_setting']) && $_POST['isdn_oad_setting'] != 'manual' && $_POST['isdn_oad_setting'] != $default['isdn_oad_setting'])
		$config .= ",isdn_oad_setting=" . $_POST['isdn_oad_setting'];
	else if (isset($_POST['isdn_oad_setting']) && $_POST['isdn_oad_setting'] == 'manual')
		$config .= ",isdn_oad_setting=" . $_POST['isdn_oad_setting_manual'];

	//ISDN_OAD2_SETTING
	if (isset($_POST['isdn_oad2_setting']) && $_POST['isdn_oad2_setting'] != 'manual' && $_POST['isdn_oad2_setting'] != $default['isdn_oad2_setting'])
		$config .= ",isdn_oad2_setting=" . $_POST['isdn_oad2_setting'];
	else if (isset($_POST['isdn_oad2_setting']) && $_POST['isdn_oad2_setting'] == 'manual')
		$config .= ",isdn_oad2_setting=" . $_POST['isdn_oad2_setting_manual'];

	//ISDN_QSIGNAME_SETTING
	if (isset($_POST['isdn_qsigname_setting']) && $_POST['isdn_qsigname_setting'] != 'manual' && $_POST['isdn_qsigname_setting'] != $default['isdn_qsigname_setting'])
		$config .= ",isdn_qsigname_setting=" . $_POST['isdn_qsigname_setting'];
	else if (isset($_POST['isdn_qsigname_setting']) && $_POST['isdn_qsigname_setting'] == 'manual')
		$config .= ",isdn_qsigname_setting=" . $_POST['isdn_qsigname_setting_manual'];

	//ISDN_REDIRECTED_NR_SETTING
	if (isset($_POST['isdn_redirected_nr_setting']) && $_POST['isdn_redirected_nr_setting'] != 'manual' && $_POST['isdn_redirected_nr_setting'] != $default['isdn_redirected_nr_setting'])
		$config .= ",isdn_redirected_nr_setting=" . $_POST['isdn_redirected_nr_setting'];
	else if (isset($_POST['isdn_redirected_nr_setting']) && $_POST['isdn_redirected_nr_setting'] == 'manual')
		$config .= ",isdn_redirected_nr_setting=" . $_POST['isdn_redirected_nr_setting_manual'];

	//ISDN_DAD_SETTING
	if (isset($_POST['isdn_dad_setting']) && $_POST['isdn_dad_setting'] != 'manual' && $_POST['isdn_dad_setting'] != $default['isdn_dad_setting'])
		$config .= ",isdn_dad_setting=" . $_POST['isdn_dad_setting'];
	else if (isset($_POST['isdn_dad_setting']) && $_POST['isdn_dad_setting'] == 'manual')
		$config .= ",isdn_dad_setting=" . $_POST['isdn_dad_setting_manual'];

	//PSTN_SRC_SETTING
	if (isset($_POST['from_pstn_src_setting_isdn']) && $_POST['from_pstn_src_setting_isdn'] != $default['from_pstn_src_setting'])
		$config .= ",from_pstn_src_setting=" . $_POST['from_pstn_src_setting_isdn'];

	//Additional config string hinzufügen.
	if ($_POST['addit_options'] != "")
		$config .= "," . str_replace(array("\r\n", "\n", "\r"), ",", $_POST['addit_options']);

	$config = trim($config, ",");

	return $config;
}

if (strtolower($_POST['group']) == "general") {
	echo "<script> alert('Invalid Group Name'); window.history.back();</script>";
	return;
}
$query_comp = $ba->select("SELECT gr FROM isdn");
while ($entry = $ba->fetch_array($query_comp)) {
	if ($_POST['gr_upd'] != $entry['gr']) {
		if ($_POST['group'] == $entry['gr']) {
			echo "<script> alert('Invalid Group Name'); window.history.back();</script>";
			return;
		}
	}
}

if ($_POST['gr_upd'] != "") {
	$query_new = $ba->update('UPDATE isdn SET gr=\'NULL\', config=\'\' WHERE gr=\'' . sqlite_escape_string($_POST['gr_upd']) . '\'');
}
$gr = $_POST['group'];
$ports = $_POST['ports'];
$chansel = $_POST['chansel'];
$chansel_dir = $_POST['chansel_dir'];
$tones = $_POST['tones'];
$portpullup = $_POST['portpullup'];
$odt = $_POST['odt'];
$odt_empty_dad = $_POST['odt_empty_dad'];
$country_code = $_POST['country_code'];
$city_code = $_POST['city_code'];
$local_area_code = $_POST['local_area_code'];
$pcmlaw = $_POST['pcmlaw'];
$port = "";
$overlap_dialing = $_POST['overlap_dialing'];
$qsig = $_POST['qsig'];
$dialtone_digits = $_POST['dialtone_digits'];
$restart_after_link_loss = $_POST['restart_after_link_loss'];
$config = parameters();

for ($i = 0; $i < count($ports); $i++) {
	$port = $ports[$i];
	$query_new = $ba->update('UPDATE isdn SET gr=\'' . sqlite_escape_string($gr) . '\', '
		. 'config=\'' . sqlite_escape_string($config) . '\', qsig=\'' . sqlite_escape_string($qsig) . '\', '
		. 'portpullup=\'' . sqlite_escape_string($portpullup) . '\', '
		. 'overlap_dialing=\'' . sqlite_escape_string($overlap_dialing) . '\', '
		. 'odt=\'' . sqlite_escape_string($odt) . '\', odt_empty_dad=\'' . sqlite_escape_string($odt_empty_dad) . '\', '
		. 'chansel=\'' . sqlite_escape_string($chansel) . '\', chansel_dir=\'' . sqlite_escape_string($chansel_dir) . '\', '
		. 'tones=\'' . sqlite_escape_string($tones) . '\', country_code=\'' . sqlite_escape_string($country_code) . '\', '
		. 'city_code=\'' . sqlite_escape_string($city_code) . '\', local_area_code=\'' . sqlite_escape_string($local_area_code) . '\', '
		. 'pcmlaw=\'' . sqlite_escape_string($pcmlaw) . '\', dialtone_digits=\'' . sqlite_escape_string($dialtone_digits) . '\', '
		. 'restart_after_link_loss=\'' . sqlite_escape_string($restart_after_link_loss) . '\' WHERE port=\'' . sqlite_escape_string($port) . '\'');
}

if (!$ba->is_error() && $_POST['gr_upd'] != "") {
	$query = $ba->update('UPDATE dialplan SET fromId=\'g:' . sqlite_escape_string($gr) . '\' where fromDirection=\'isdn\' and fromId=\'g:' . sqlite_escape_string($_POST['gr_upd']) . '\'');
	$query = $ba->update('UPDATE dialplan SET toId=\'g:' . sqlite_escape_string($gr) . '\' where toDirection=\'isdn\' and toId=\'g:' . sqlite_escape_string($_POST['gr_upd']) . '\'');
}

Helper::activate(2);
//Weiterleitung
if (!$ba->is_error()) {
	echo "<script>window.location='../../index.php?m=Isdn&opt=" . strtolower($_GET['opt']) . "'</script>";
} else {
	echo "<script>alert(" . $ba->error() . ");</script>";
}
?>
